import pyerrors.input.openQCD as input
import datalad.api as dl
import os
import fnmatch
from typing import Any


def read_param(path: str, project: str, file_in_project: str) -> dict[str, Any]:
    file = path + "/projects/" + project + '/'  + file_in_project
    dl.get(file, dataset=path + "/projects/" + project)
    with open(file, 'r') as fp:
        lines = fp.readlines()
        fp.close()
    param = {}
    param['rw_fcts'] = []
    param['rand'] = {}

    for line in lines:
        if line.startswith('#'):
            continue
        if line.startswith('\n'):
            continue

        if line.startswith("nrw"):
            l = line.strip()
            num_rw = l.split('#').split()[1]

    return param

# reweighting factors (len nrw)

#   void read_rw_parms(int irw)
#     On process 0, this program scans stdin for a line starting with the
#     string "[Reweighting factor <int>]" (after any number of blanks), where
#     <int> is the integer value passed through the argument. An error occurs
#     if no such line or more than one is found. The lines
#
#       rwfact   <rwfact_t>
#       im0      <int>
#       nsrc     <int>
#       irp      <int>
#       mu       <double> [<double>]
#       np       <int> [<int>]
#       isp      <int> [<int>]
    

def read_rwms(path: str, project: str, dir_in_project: str, prefix, postfix="ms1", version='2.0', names=None, files=None):
    
    directory = path + "/projects/" + project + '/' + dir_in_project
    if files is None:
        files = []
        for root, ds, fs in os.walk(directory):
            for f in fs:
                if fnmatch.fnmatch(f, prefix + "*" + postfix + ".dat"):
                    files.append(f)
    dl.get([directory + "/" + f for f in files], dataset=path + "/projects/" + project)
    kwargs = {}
    if names is not None:
        kwargs['names'] = names
    if files is not None:
        kwargs['files'] = files
    rwms = input.read_rwms(directory, prefix, version, **kwargs)
    print(rwms)
    rw_dict: dict[str, Any] = {}
    rw_dict[''] = 
    return rw_dict